function init(hero) {
    hero.setName("Vlad Plasmius");
    hero.setTier(6);
    
    hero.setChestplate("item.superhero_armor.piece.chestpiece");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");
    
    hero.addPowers("tmfp:vlad_powers");

    hero.addKeyBind("ENERGY_PROJECTION", "Ghost Ray", 1);
    hero.addKeyBind("SPELL_MENU", "Spectral Copies", 2);
    hero.addKeyBind("INTANGIBILITY", "key.intangibility", 3);
    hero.addKeyBind("INVISIBILITY", "key.invisibility", 4);
    hero.addKeyBind("STEEL_TRANSFORM", "Ghost Form", 5);

    hero.addAttribute("FALL_RESISTANCE", 3.0, 0);
    hero.addAttribute("PUNCH_DAMAGE", 3.0, 0);
    hero.addAttribute("SPRINT_SPEED", 0.2, 1);

    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setTierOverride(getTierOverride);
    hero.addAttributeProfile("INACTIVE", inactiveProfile);
    hero.setAttributeProfile(getProfile);
    hero.supplyFunction("canAim", canAim);
    hero.setDefaultScale(1.1);
}
function getTierOverride(entity) {
    return entity.getData("fiskheroes:dyn/steeled") ? 6 : 0;
}
function inactiveProfile(profile) {
    profile.revokeAugments();
}
function getProfile(entity) {
    if (!entity.getData("fiskheroes:dyn/steeled")) {
        return "INACTIVE";
    }
}
function isModifierEnabled(entity, modifier) {
    if (modifier.name() != "fiskheroes:transformation" && modifier.name() != "fiskheroes:cooldown" && (!entity.getData("fiskheroes:dyn/steeled") && entity.getData("fiskheroes:dyn/steel_timer") < 1)) {
        return false;
    }
    switch (modifier.name()) {
    case "fiskheroes:energy_blast":
        return entity.getData("fiskheroes:aimed_timer") >= 1;
    default:
        return true;
    }
}
function isKeyBindEnabled(entity, keyBind) {
    if (keyBind == "STEEL_TRANSFORM") {
        return entity.getData("fiskheroes:mask_open_timer") == 0;
    }
    else if (!entity.getData("fiskheroes:dyn/steeled")) {
        return false;
    }
    
    switch (keyBind) {
    case "SONIC_WAVES":
        return entity.isSneaking();
    case "CHARGE_ICE":
        return !entity.isSneaking();
    default:
        return true;
    }
}
function canAim(entity) {
    return entity.getHeldItem().isEmpty() && entity.getData("fiskheroes:dyn/steeled");
}
